//
// Segmap.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Segmap: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var mediaId: Int?
    public var mask: String?
    public var area: Int?
    public var boundingBox: [Int]?
    public var hash: String?
    public var classId: Int?
    public var isCrowd: Int?
    public var segmentation: String?
    public var confidence: Float?
    public var source: String?
    public var attributes: [Attribute]?
    public var updatedAt: Date?
    public var createdAt: Date?
    public var media: Media?

    public init(id: Int? = nil, mediaId: Int? = nil, mask: String? = nil, area: Int? = nil, boundingBox: [Int]? = nil, hash: String? = nil, classId: Int? = nil, isCrowd: Int? = nil, segmentation: String? = nil, confidence: Float? = nil, source: String? = nil, attributes: [Attribute]? = nil, updatedAt: Date? = nil, createdAt: Date? = nil, media: Media? = nil) {
        self.id = id
        self.mediaId = mediaId
        self.mask = mask
        self.area = area
        self.boundingBox = boundingBox
        self.hash = hash
        self.classId = classId
        self.isCrowd = isCrowd
        self.segmentation = segmentation
        self.confidence = confidence
        self.source = source
        self.attributes = attributes
        self.updatedAt = updatedAt
        self.createdAt = createdAt
        self.media = media
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case mediaId
        case mask
        case area
        case boundingBox
        case hash
        case classId
        case isCrowd
        case segmentation
        case confidence
        case source
        case attributes
        case updatedAt
        case createdAt
        case media = "Media"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(mediaId, forKey: .mediaId)
        try container.encodeIfPresent(mask, forKey: .mask)
        try container.encodeIfPresent(area, forKey: .area)
        try container.encodeIfPresent(boundingBox, forKey: .boundingBox)
        try container.encodeIfPresent(hash, forKey: .hash)
        try container.encodeIfPresent(classId, forKey: .classId)
        try container.encodeIfPresent(isCrowd, forKey: .isCrowd)
        try container.encodeIfPresent(segmentation, forKey: .segmentation)
        try container.encodeIfPresent(confidence, forKey: .confidence)
        try container.encodeIfPresent(source, forKey: .source)
        try container.encodeIfPresent(attributes, forKey: .attributes)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(media, forKey: .media)
    }
}

